#!/bin/sh
# (rpm)trigger script for okas
# $Id: triggerin.sh,v 1.7 2004/03/17 22:01:04 glen Exp $
. /usr/lib/okas/functions
umask 002

case "$1" in
vim)
	vimrc=`vim --version 2>/dev/null | awk '/system vimrc/ {print $NF}' | xargs`

	if [ "$vimrc" ]; then
		PatchFile "$vimrc" \
			'"?.*so.*vim/okas\.vim' \
			's|^"\?.*so.*vim/okas\.vim.*$|so /usr/share/okas/vim/okas.vim|g' \
			'so /usr/share/okas/vim/okas.vim'
	fi
;;


bashrc)
	# bashrc
	if [ -f /etc/bash.bashrc ]; then # SuSE
		bashrc=/etc/bash.bashrc.local

	elif [ -f /etc/bashrc.local ]; then # we
		bashrc=/etc/bashrc.local

	else
		bashrc=/etc/bashrc

	fi

	PatchFile $bashrc \
		'#?.*okas/bashrc' \
		's|^#\?.*okas/bashrc.*$|test "$PS1" -a "$BASH_VERSION" \&\& . /usr/share/okas/bashrc|g' \
		'test "$PS1" -a "$BASH_VERSION" && . /usr/share/okas/bashrc'
;;


hosts)
	host=`hostname -f`
	case $host in
	*.delfi.* | *.online.ee)
		if /sbin/route -n | grep -q '^192.168.5.' ; then
			localip='/usr/share/okas/hosts.delfi.ee'
		fi
		# insert or replace delfi hostnames
		PatchFile /etc/hosts \
			'delfi.hosts' \
			"
			/^# START delfi.hosts/,/^# END delfi.hosts/ {
				/^# END/b
				/^# START/ {
					s/^.*\$/# START delfi.hosts (from okas package)/
					p
					${localip:+r $localip}
					r /usr/share/okas/hosts.delfi
				}
				d
			}
		" \
		"
# START delfi.hosts from (okas package)
`cat $localip /usr/share/okas/hosts.delfi 2>/dev/null`
# END delfi.hosts

"
	;;
	esac
;;


sysctl.conf)
	if [ "`uname -s`" = Linux ]; then
		# hack /etc/sysctl.conf
		for key in `sed -e '/^#/d;/^$/d;s/ .*//' /usr/share/okas/sysctl.conf`; do
			grep -q "^[# ]*$key" /etc/sysctl.conf && continue
			sed -e '/./{H;$!d;}' -e "x;/$key/!d" /usr/share/okas/sysctl.conf >> /etc/sysctl.conf
		done
	fi

;;


rpm.macros)
	# RPM tune
	if [ -d /var/lib/rpm ]; then
		[ ! -d /etc/rpm ] && mkdir -m 755 /etc/rpm
		[ ! -f /etc/rpm/macros ] && touch /etc/rpm/macros

		# enable _install_langs only when it was commented out. don't force
		PatchFile /etc/rpm/macros \
			'^#?%_install_langs.*$' \
			's|^#.*\(%_install_langs\)|\1|g' \
			'%_install_langs et_EE:lv_LV:lt_LT:ru_RU:en_US'
	fi
;;


XTerm|XFree86)
	# XTerm App-Defaults
	PatchFile \
		/usr/X11R6/lib/X11/app-defaults/XTerm \
		'!?.*#include.*okas/XTerm.ad"' \
		's|^!\?.*#include.*okas/XTerm.ad".*$|#include "/usr/share/okas/XTerm.ad"|g' \
		'#include "/usr/share/okas/XTerm.ad"'

;;

sshd_config)
	old=`mktemp ${TMPDIR:-/tmp}/sshdXXXXXX`
	cp /etc/ssh/sshd_config $old
	dosed /etc/ssh/sshd_config \
		"
		/^#Protocol /s:.*:Protocol 2:
		/^#PermitRootLogin /s:.*:PermitRootLogin no:
		"

	if ! cmp $old /etc/ssh/sshd_config &>/dev/null; then
		echo >&2 "WARNING:"
		echo >&2 "WARNING: !!! sshd_config was modified to change PermitRootLogin or Protocol value."
		echo >&2 "WARNING: !!! You have explicitly enable them back if you need root logins or ssh protocol version 1."
		echo >&2 "WARNING:"

		if [ -f /var/lock/subsys/sshd ]; then
			/etc/rc.d/init.d/sshd restart
		fi
	fi
	rm -f $old
;;
esac
